
/******************************************************************
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************/


/* Define this if you have applied the "khttpd.diff" patch to your
   kernel */
   
#undef HAVE_DO_GENERIC_FILE_READ
#undef HAVE_TCP_CORK


#include <linux/time.h>

/* Configuration options */

#define KHTTPD_PORT		80
#define KHTTPD_CLIENTPORT	81
#define KHTTPD_BUFSIZE		4096
#define KHTTPD_PREFIX		"/var/www"
#define KHTTPD_MAXACCEPT	40
#define	KHTTPD_MINACCEPT	5
#define KHTTPD_NUMMIMETYPES	20
#define KHTTPD_SLEEPVALUE	10
#define KHTTPD_DATEDELAY	(HZ/KHTTPD_SLEEPVALUE)

#ifndef TASK_WAKE_ONE
#define TASK_WAKE_ONE	32
#endif

/* Structures */

struct http_time
{
	time_t 	UnixTime;
	char	MimeTime[256];
};


/* prototypes */

static inline _syscall3(pid_t,waitpid,pid_t,pid,int *,wait_stat,int,options)

size_t SendBuffer(struct socket *sock, const char *Buffer, size_t Length);
size_t SendBuffer2(struct socket *sock, const char *Buffer1, size_t Length1,
		   const char *Buffer2, size_t Length2);
 void Error404(struct socket *sock);
 void Error403(struct socket *sock);
 void Error304(struct socket *sock);
 void ErrorXXX(struct socket *sock, int Error);
 char *HTTPHeader(char *Filename,int FileSize,time_t ModTime, struct http_time *httptime);
 void AddMimeType(char *Ident,char *Type);

 int  khttp_copy_filp_to_sock(struct file *filp,struct socket *sock, size_t FileLength, const char *Header);
 int  HandleIncommingConnection(struct socket *sock, char *Buffer, size_t *BufLen, struct http_time *httptime);
 void NeedSpawn(struct socket *sock);
 void time_Unix2RFC(time_t Zulu, char *Buffer);
 void UpdateCurrentDate();


int khttpdaemon(void *unused);
int khttpd_child(void *TMP);

extern char CurrentTime[];

#ifdef VERBOSE
#define DebugStr(x) printk(x)
#else
#define DebugStr(x)
#endif


struct http_header
{
	char 	FileName[256];
	char	IMS[128];
	char	Agent[256];
	char	Host[128];
	
	char 	Padding[4096-256-128-256-128];
};
void ParseHeader(char *Buffer,int length, struct http_header *Head);
time_t mimeTime_to_UnixTime(char *Q);


