
#include <linux/time.h>
#include <linux/kernel.h>
#include <linux/malloc.h>
#include <linux/ctype.h>

#include "times.h"

char *dayName[7] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

char *monthName[12] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};


char CurrentTime[64];



void time_Unix2RFC(time_t Zulu,char *Buffer)
{
	int Y,M,D;
	int H,Min,S,WD;
	int I,I2;
	time_t rest;
	
	
	I=0;
	while (I<KHTTPD_NUMYEARS)
	{
		if (TimeDays[I][0]>Zulu) 
		   break;
		I++;
	}
	
	Y=--I;
	if (I<0) Y=0;
	
	I2=0;
	while (I2<=12)
	{
		if (TimeDays[I][I2]>Zulu) 
		   break;
		I2++;
	}			   
	
	M=I2-1;
	
	rest=Zulu - TimeDays[Y][M];
	WD=WeekDays[Y][M];
	D=rest/86400;
	rest=rest-D*86400;
	WD+=D;
	WD=WD%7;
	H=rest/3600;
	rest=rest-H*3600;
	Min=rest/60;
	rest-=Min*60;
	S=rest;
	Y+=KHTTPD_YEAROFFSET;
	
	
	/* Format:  Day, 01 Mon 1999 01:01:01 GMT */
	
	sprintf( Buffer, "%s, %02i %s %04i %02i:%02i:%02i GMT",
		dayName[ WD ], D+1, monthName[ M ], Y,
		H, Min, S
	);
		
	
}

void UpdateCurrentDate()
{
   struct timeval tv;
   
   do_gettimeofday(&tv);
   time_Unix2RFC(tv.tv_sec,CurrentTime);
}

int MonthHash[32] = {0,0,7,0,0,0,0,0,0,0,0,3,0,0,0,2,6,0,5,0,9,8,4,0,0,11,1,10,0,0,0,0};

#define is_digit(c)	((c) >= '0' && (c) <= '9')

static int skip_atoi(char **s)
{
	int i=0;

	while (is_digit(**s))
		i = i*10 + *((*s)++) - '0';
	return i;
}

time_t mimeTime_to_UnixTime(char *Q)
{
	int Y,M,D,H,Min,S;
	int Hash;
	time_t Temp;
	char *s,**s2;
	
	s=Q;
	s2=&s;
	
	if (strlen(s)<30) return 0;
	if (s[3]!=',') return 0;
	if (s[19]!=':') return 0;
	
	s+=5; /* Skip day of week */
	D = skip_atoi(s2);  /*  Day of month */
	s++;
	Hash = s[0]+s[2];
	Hash = (Hash<<1) + s[1];
	Hash = (Hash&63)>>1;
	M = MonthHash[Hash];
	s+=4;
	Y = skip_atoi(s2); /* Year */
	s++;
	H = skip_atoi(s2); /* Hour */
	s++;
	Min = skip_atoi(s2); /* Minutes */
	s++;
	S = skip_atoi(s2); /* Seconds */
	s++;
	if ((s[0]!='G')||(s[1]!='M')||(s[2]!='T')) 
	{	
  		return 0; /* No GMT */
  	}

	if (Y<KHTTPD_YEAROFFSET) Y = KHTTPD_YEAROFFSET;
	if (Y>KHTTPD_YEAROFFSET+9) Y = KHTTPD_YEAROFFSET+9;
	
	Temp = 	TimeDays[Y-KHTTPD_YEAROFFSET][M];
	Temp += D*86400+H*3600+M*30+S;
	
	return Temp;  
}