/*

This program generates the "times.h" file with the zulu-times of the first of
every month of a decade.

*/

#include <time.h>
#include <stdio.h>


time_t GetDay(int D,int M,int Y)
{
	struct tm TM;
	
	TM.tm_sec    	= 0;
	TM.tm_min	= 0;
	TM.tm_hour	= 0;
	TM.tm_mday	= D;
	TM.tm_mon	= M;
	TM.tm_year	= Y-1900;
	TM.tm_isdst	= 0;
	
	return mktime(&TM);
	
}
int WeekGetDay(int D,int M,int Y)
{
	struct tm TM;
	
	TM.tm_sec    	= 0;
	TM.tm_min	= 0;
	TM.tm_hour	= 0;
	TM.tm_mday	= D;
	TM.tm_mon	= M;
	TM.tm_year	= Y-1900;
	TM.tm_isdst	= 0;
	
	mktime(&TM);
	
	return TM.tm_wday;
	
}

void main()
{
	int M,Y;
	FILE *file;
	
	file=fopen("times.h","w");
	
	fprintf(file,"time_t TimeDays[10][13] = { \n");
	
	Y=1997;
	while (Y<2007)
	{
		M=0;
		fprintf(file," { ");
		while (M<12)
		{
			fprintf(file,"%i",(int)GetDay(1,M,Y));
     		  	fprintf(file,",\t");
		
			M++;
		}
		
		fprintf(file,"%i } ",(int)GetDay(1,0,Y+1));
		if (Y!=2006) fprintf(file,",");
		fprintf(file,"\n");
		Y++;
	}
	fprintf(file,"};\n");

	fprintf(file,"int WeekDays[10][13] = { \n");
	
	Y=1997;
	while (Y<2007)
	{
		M=0;
		fprintf(file," { ");
		while (M<12)
		{
			fprintf(file,"%i",(int)WeekGetDay(1,M,Y));
     		  	fprintf(file,",\t");
		
			M++;
		}
		
		fprintf(file,"%i } ",(int)WeekGetDay(1,0,Y+1));
		if (Y!=2006) fprintf(file,",");
		fprintf(file,"\n");
		Y++;
	}
	fprintf(file,"};\n");
	fprintf(file,"#define KHTTPD_YEAROFFSET   1997\n");
	fprintf(file,"#define KHTTPD_NUMYEARS     10\n");
	fclose(file);
}